//+------------------------------------------------------------------+
//|                                                       EA_FDM.mq4 |
//|                                 Copyright  2009, Andrea De Mori |
//|                                         andrea.demori@hotmail.it |
//|                                                                  |
//| Description:                                                     |
//| EA basato sul Trading System Forex Day Monster                   |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//| Patch history:                                                   |
//+------------------------------------------------------------------+
#property copyright "Andrea De Mori"
#property link      "andrea.demori@hotmail.it"
#include <WinUser32.mqh>
//=================================================================================================

extern bool    ActiveDebug             = FALSE;  
extern int     OpenHour                = 8;
extern int     CloseHour               = 19;
extern int     Slippage                = 3;
extern double  Lots                    = 0.01;
extern bool    LotsOptimized           = TRUE;
extern double  Risk                    = 2;
extern double  MaxLots                 = 3;
extern int     MagicNumber             = 12345;
//Se lo StopLoss  minore del valore dell'indicatore ADR viene sovrascritto
extern double  StopLoss                = 0;
extern double  TakeProfit              = 0;
//Se acceso, permettono di nascondere il TP e lo SL
extern bool    Hidden_TPSL             = FALSE;
extern int     MaxBarAfterArrow        = 8;
//Se acceso, permette di chiudere le operazioni in base alle regole
//descritte dall'autore del TradingSystem.
extern bool    CloseOnRulesSystem      = TRUE;
//Se il prezzo  distante dalla resistenza/supporto pi del valore
//indicato dal parametro, il TP viene impostato con la resistenza/supporto
//altrimenti il TP viene impostato a 0
//Questo permette di pilotare il TakeProfit sulla resistenza o sugli
//indicatori successivi
extern double  DistanceFromSR          = 30; 
//Ogni carattere della stringa, rappresenta il flag (0=spento, 1=acceso) dell'indicatore associato.
//Il flag 1 rappresenta l'indicatore FDM Buy Sell Pressure
//Il flag 2 rappresenta l'indicatore FDM Buy Sell Pressure #2
//Il flag 3 rappresenta l'indicatore FDM_Multi-Trend
//Le combinazioni possibili sono le seguenti: 
// Regola1=100
// Regola2=110
// Regola3=111
// Regola4=101
// Regola5=010
// Regola6=011
// Regola7=001 
extern bool    FlagExitRuleSystem1     = FALSE;
extern bool    FlagExitRuleSystem2     = TRUE;
extern bool    FlagExitRuleSystem3     = TRUE;
extern bool    FlagExitRuleSystem4     = TRUE;
extern bool    FlagExitRuleSystem5     = FALSE;
extern bool    FlagExitRuleSystem6     = TRUE;
extern bool    FlagExitRuleSystem7     = TRUE;

extern string  ListParam1              = "*** Parametri per indicatore di correlazione ***";  
extern bool    UseCorrelation          = TRUE;
extern double  PercCorrelation         = 60;
extern int     TypeCorrelation         = 2;        //(1 = Correlazione a coppie; 2 = Correlazione assoluta) 
//extern string  c_OtherChart            = "EURUSD";
extern int     c_Points                = 50;
extern bool    c_UseOpen               = TRUE;
extern bool    c_UseClose              = FALSE;
extern bool    c_UseHigh               = FALSE;
extern bool    c_UseLow                = FALSE;
extern int     c_CalcBars              = 100;

//=================================================================================================
string         EAName                  = "EA_FDM";
int            TicketPos               = 0;

string         strSignal               = "";

bool           boolArrowSell;
bool           boolArrowBuy;
int            intBarArrow;
datetime       dtArrow;                 
bool           boolPrompt;
int            ret;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "init()");

   Slippage       = Slippage * SetBrokerX();
   TakeProfit     = TakeProfit * SetBrokerX(); 
   StopLoss       = StopLoss * SetBrokerX(); 
   DistanceFromSR = DistanceFromSR * SetBrokerX();

   if (ActiveDebug) {
      Print(EAName + "| " + "Slippage        : ", Slippage);
      Print(EAName + "| " + "TakeProfit      : ", TakeProfit);
      Print(EAName + "| " + "StopLoss        : ", StopLoss);
      Print(EAName + "| " + "DistanceFromSR  : ", DistanceFromSR);
   }

   if (CloseOnRulesSystem)
      TakeProfit = 0;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "deinit()");

   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "start()");

   //if (TimeCurrent() > D'2009.04.30 00:00') {
   //   Print("Errore: " + "Il periodo di prova  scaduto");
   //   return(0);
   //}

   if (Period() < 5 || Period() > 240) {
      Alert(EAName + "| " + "Usare TF maggiore o uguale al 5 minuti e minore o uguale al 4 ore");
      return(0);
   }

   if (DistanceFromSR < MarketInfo(Symbol(),MODE_STOPLEVEL)) {
      Alert(EAName + "| " + "Il valore del parametro DistanceFromSR deve essere maggiore o uguale di " + MarketInfo(Symbol(),MODE_STOPLEVEL));
      return(0);
   }

   static datetime   prevtime          = 0;
   static bool       boolSignal        = FALSE;
   
   if (prevtime == Time[0]) {

      //Se il valore  maggiore di 0, allora significa che ho gi aperto
      //la posizione da quando si  verificato l'ultimo segnale Arrow e quindi
      //se la posizione  ancora aperta devo controllarne la chiusura in caso
      //di SL o TP nascosti
      if (TicketPos > 0) {
         if (Hidden_TPSL)
            GestioneTPSL();
      } 
      else {
         //Se si  verificato il segnale e se sono in orario di trade
         //elaboro il segnale con conseguente apertura delle operazioni
         if (boolSignal && IsTradeTime(TimeCurrent()))
            ElaboraSegnale();
      }
                     
      return(0);
   }
   else {
      boolPrompt = TRUE;
      
      prevtime = Time[0];      

      boolSignal = GetSignal(1);

      TicketPos = RecuperaPosizione();

      //Se il flag  attivo, applico le regole di chiusura
      //come definito dall'autore del TradingSystem
      if (CloseOnRulesSystem)
         ControlloPosizioni();

      //Se la posizione  ancora aperta e si  verificato un segnale ARROW
      //forzo la chiusura dell'operazione (Dovrebbe essere un caso molto raro)
      if (TicketPos > 0 && (boolArrowBuy || boolArrowSell))
         CtrlClosePos();
               
      if (boolSignal && TicketPos <=0)
         Alert(EAName +" SEGNALE: " + strSignal + " Pair " + Symbol());
   }   
      
   return(0);
}
//=================================================================================================
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ElaboraSegnale() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "ElaboraSegnale()");

   //Controllo sulla correlazione
   if ((UseCorrelation && TestCorrelation(strSignal)) || !UseCorrelation)
      if (boolPrompt)
         ApriPosizioni(strSignal);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ApriPosizioni(string strSignal) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "ApriPosizioni() ", strSignal);

   //Richiesta di conferma apertura posizioni
   ret = MessageBox("Confermi l''apertura di una posizione " + strSignal + " per il pair " + Symbol() + "?", EAName + " - Conferma operazione",MB_YESNO|MB_ICONQUESTION);
   if (ret == IDNO) {
      boolPrompt = FALSE;      
      return(0);
   }
   
   double sl;
   double slHidden;
   double slForLots;
   double slPips;

   int err            = 0;
   int c              = 0;
   int NumberOfTries  = 100;
   
   TicketPos = 0;
   
   if (ActiveDebug) {
      Print(EAName + "| " + "Bid: ", Bid);
      Print(EAName + "| " + "Ask: ", Ask);
   }

   sl = GetStopLoss(strSignal);
   slHidden = 0;
   if (Hidden_TPSL)
      slHidden = GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "StopLoss_Pos"); 
   if (sl > 0)
      slForLots = sl;
   else
      slForLots = slHidden;

   RefreshRates();
   if (strSignal == "BUY")
      slPips = NormalizeDouble(Ask - slForLots, Digits) / Point ;  
   if (strSignal == "SELL")
      slPips = NormalizeDouble(slForLots - Bid, Digits) / Point ;  

   if (ActiveDebug) {
      Print(EAName + "| " + "slPips: ", slPips);
   }

   //Apro la posizione
   if (strSignal == "BUY") {   
      for (c=0;c<NumberOfTries;c++) {
         RefreshRates();                   
         
         TicketPos = OrderSend(Symbol(), OP_BUY, GetLots(slPips), Ask, Slippage, sl, GetTakeProfit(strSignal), GetComment(), MagicNumber, 0, Blue);
         err = GetLastError();
         if (err == 0) {
            break;
         }
         else {
            Alert(EAName + "| " + "Errore OrderSend BUY: ", err);
            if (err==4 || err==137 ||err==146 || err==136) {
               Sleep(3000);
               continue;
            }
            else {
               break;
            }
         }      
      }
   }

   if (strSignal == "SELL") {
      for (c=0;c<NumberOfTries;c++) {
         RefreshRates();                   
         
         TicketPos = OrderSend(Symbol(), OP_SELL, GetLots(slPips), Bid, Slippage, sl, GetTakeProfit(strSignal), GetComment(), MagicNumber, 0, Red);
         err = GetLastError();
         if (err == 0) {
            break;
         }
         else {
            Alert(EAName + "| " + "Errore OrderSend SELL: ", err);
            if (err==4 || err==137 ||err==146 || err==136) {
               Sleep(3000);
               continue;
            }
            else {
               break;
            }
         }      
      }
   }
      
   boolPrompt = FALSE;      
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ControlloPosizioni() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "ControlloPosizioni()");

   double   dblICustom0;
   double   dblICustom1;
   double   dblICustom2;
   double   dblICustom3;

   bool     boolInd1Buy = FALSE;
   bool     boolInd1Sell = FALSE;
   bool     boolInd2Buy = FALSE;
   bool     boolInd2Sell = FALSE;
   bool     boolInd4Buy = FALSE;
   bool     boolInd4Sell = FALSE;

   int err            = 0;
   int c              = 0;
   int NumberOfTries  = 100;

   //INDICATORE 1: FDM Buy Sell Pressure
   //Se verde buffer 1 diverso da EMPTY_VALUE altrimenti se rosso
   //buffer 0 diverso da EMPTY_VALUE. I buffer 2 e 3 sembrano non essere significativi per il nostro scopo 
   //Buffer 0 segnala un SELL
   //Buffer 1 segnala un BUY
   dblICustom0 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",0, 1);
   dblICustom1 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",1, 1);
   //dblICustom2 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",2, 1);
   //dblICustom3 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",3, 1);

   if (ActiveDebug) {
      Print(EAName + "| " + "FDM Buy Sell Pressure-0:", dblICustom0);
      Print(EAName + "| " + "FDM Buy Sell Pressure-1:", dblICustom1);
      //Print(EAName + "| " + "FDM Buy Sell Pressure-2:", dblICustom2);
      //Print(EAName + "| " + "FDM Buy Sell Pressure-3:", dblICustom3);
   }   

   if (dblICustom0 == EMPTY_VALUE) {
      if (dblICustom1 == EMPTY_VALUE) {
      }
      else {
         boolInd1Buy = TRUE;
      }
   }
   else {
      boolInd1Sell = TRUE;
   }         

   //INDICATORE 2: FDM Buy Sell Pressure #2
   //Se verde buffer 1 diverso da EMPTY_VALUE altrimenti se rosso
   //buffer 0 diverso da EMPTY_VALUE. I buffer 2 e 3 sembrano non essere significativi per il nostro scopo 
   //Buffer 0 segnala un SELL
   //Buffer 1 segnala un BUY
   dblICustom0 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",0, 1);
   dblICustom1 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",1, 1);
   //dblICustom2 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",2, 1);
   //dblICustom3 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",3, 1);

   if (ActiveDebug) {
      Print(EAName + "| " + "FDM Buy Sell Pressure #2-0:", dblICustom0);
      Print(EAName + "| " + "FDM Buy Sell Pressure #2-1:", dblICustom1);
      //Print(EAName + "| " + "FDM Buy Sell Pressure #2-2:", dblICustom2);
      //Print(EAName + "| " + "FDM Buy Sell Pressure #2-3:", dblICustom3);
   }   

   if (dblICustom0 == EMPTY_VALUE) {
      if (dblICustom1 == EMPTY_VALUE) {
      }
      else {
         boolInd2Buy = TRUE;
      }
   }
   else {
      boolInd2Sell = TRUE;
   }         

   //INDICATORE 4: FDM_Multi-Trend
   //Se verde buffer 1 diverso da 0 altrimenti se rosso
   //buffer 0 diverso da 0. I buffer 2 e 3 sembrano non essere significativi per il nostro scopo 
   //Buffer 0 segnala un SELL
   //Buffer 1 segnala un BUY
   dblICustom0 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 0, 1);
   dblICustom1 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 1, 1);
   //dblICustom2 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 2, 1);
   //dblICustom3 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 3, 1);
         
   if (ActiveDebug) {
      Print(EAName + "| " + "FDM_Multi-Trend-0:", dblICustom0);
      Print(EAName + "| " + "FDM_Multi-Trend-1:", dblICustom1);
      //Print(EAName + "| " + "FDM_Multi-Trend-2:", dblICustom2);
      //Print(EAName + "| " + "FDM_Multi-Trend-3:", dblICustom3);
   }   
        
   if (dblICustom0 == 0) {
      if (dblICustom1 == 0) {
      }
      else {
         boolInd4Buy = TRUE;
      }
   }
   else {
      boolInd4Sell = TRUE;
   }         

   //Selezione la posizione
   if (OrderSelect(TicketPos, SELECT_BY_TICKET)) {
      //Verifico che la posizione sia aperta
      if (OrderCloseTime() == 0) {
         if (OrderType() == OP_BUY) {
            //Se una delle seguenti condizioni del TradingSystem  vera
            //viene chiusa la posizione
            if ((FlagExitRuleSystem1 && boolInd1Sell && boolInd2Buy && boolInd4Buy)   ||
                (FlagExitRuleSystem2 && boolInd1Sell && boolInd2Sell && boolInd4Buy)  ||
                (FlagExitRuleSystem3 && boolInd1Sell && boolInd2Sell && boolInd4Sell) ||
                (FlagExitRuleSystem4 && boolInd1Sell && boolInd2Buy && boolInd4Sell)  ||
                (FlagExitRuleSystem5 && boolInd1Buy && boolInd2Sell && boolInd4Buy)   ||
                (FlagExitRuleSystem6 && boolInd1Buy && boolInd2Sell && boolInd4Sell)  ||
                (FlagExitRuleSystem7 && boolInd1Buy && boolInd2Buy && boolInd4Sell)) {

               //Richiesta di conferma chiusura posizioni
               ret = MessageBox("Confermi la chiusura della una posizione " + strSignal + " per il pair " + Symbol() + "?", EAName + " - Conferma operazione",MB_YESNO|MB_ICONQUESTION);
               if (ret == IDNO) {
                  return(0);
               }

               for (c=0;c<NumberOfTries;c++) {
                  RefreshRates();                   
               
                  OrderClose(OrderTicket(),OrderLots(), Bid, Slippage, Lime);
                  err = GetLastError();
                  if (err == 0) {
                     break;
                  }
                  else {
                     Alert(EAName + "| " + "Errore OrderClose BUY: ", err);
                     if (err==4 || err==137 ||err==146 || err==136) {
                        Sleep(3000);
                        continue;
                     }
                     else {
                        break;
                     }
                  }      
               }                  
            }   
         }
         
         if (OrderType() == OP_SELL) {
            //Se una delle seguenti condizioni del TradingSystem  vera
            //viene chiusa la posizione
            if ((FlagExitRuleSystem1 && boolInd1Buy && boolInd2Sell && boolInd4Sell) ||
                (FlagExitRuleSystem2 && boolInd1Buy && boolInd2Buy && boolInd4Sell)  ||
                (FlagExitRuleSystem3 && boolInd1Buy && boolInd2Buy && boolInd4Buy)   ||
                (FlagExitRuleSystem4 && boolInd1Buy && boolInd2Sell && boolInd4Buy)  ||
                (FlagExitRuleSystem5 && boolInd1Sell && boolInd2Buy && boolInd4Sell) ||
                (FlagExitRuleSystem6 && boolInd1Sell && boolInd2Buy && boolInd4Buy)  ||
                (FlagExitRuleSystem7 && boolInd1Sell && boolInd2Sell && boolInd4Buy)) {

               //Richiesta di conferma chiusura posizioni
               ret = MessageBox("Confermi la chiusura della una posizione " + strSignal + " per il pair " + Symbol() + "?", EAName + " - Conferma operazione",MB_YESNO|MB_ICONQUESTION);
               if (ret == IDNO) {
                  return(0);
               }

               for (c=0;c<NumberOfTries;c++) {
                  RefreshRates();                   
                  
                  OrderClose(OrderTicket(),OrderLots(), Ask, Slippage, Lime);
                  err = GetLastError();
                  if (err == 0) {
                     break;
                  }
                  else {
                     Alert(EAName + "| " + "Errore OrderClose SELL: ", err);
                     if (err==4 || err==137 ||err==146 || err==136) {
                        Sleep(3000);
                        continue;
                     }
                     else {
                        break;
                     }
                  }      
               }
            }   
         }   
      }
   }   
}
//+------------------------------------------------------------------+
//|Chiusura della posizione se si verifica un segnale Arrow di segno |
//|contrario alla posizione gi aperta                               |
//+------------------------------------------------------------------+
void CtrlClosePos() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "CtrlClosePos()");

   int err            = 0;
   int c              = 0;
   int NumberOfTries  = 100;

   //Selezione la posizione
   if (OrderSelect(TicketPos, SELECT_BY_TICKET)) {
      //Verifico che la posizione sia aperta
      if (OrderCloseTime() == 0) {
         if (OrderType() == OP_BUY && boolArrowSell) {
            for (c=0;c<NumberOfTries;c++) {
               RefreshRates();                   

               OrderClose(OrderTicket(),OrderLots(), Bid, Slippage, Lime);         
               err = GetLastError();
               if (err == 0) {
                  break;
               }
               else {
                  Alert(EAName + "| " + "Errore OrderClose BUY: ", err);
                  if (err==4 || err==137 ||err==146 || err==136) {
                     Sleep(3000);
                     continue;
                  }
                  else {
                     break;
                  }
               }      
            }
         }   

         if (OrderType() == OP_SELL && boolArrowBuy) {
            for (c=0;c<NumberOfTries;c++) {
               RefreshRates();                   

               OrderClose(OrderTicket(),OrderLots(), Ask, Slippage, Lime);
               err = GetLastError();
               if (err == 0) {
                  break;
               }
               else {
                  Alert(EAName + "| " + "Errore OrderClose SELL: ", err);
                  if (err==4 || err==137 ||err==146 || err==136) {
                     Sleep(3000);
                     continue;
                  }
                  else {
                     break;
                  }
               }      
            }
         }   
      }
   }   
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GestioneTPSL() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "GestioneTPSL()");

   int err            = 0;
   int c              = 0;
   int NumberOfTries  = 100;

   //Se le variabili globali non esistono, significa che vi  stato un qualche errore grave
   //e quindi i valori dello StopLoss e del TakeProfit non esistono pi.
   //Le variabili globali vengono memorizzate sull'harddisk per 4 settimane
   if (!GlobalVariableCheck(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "StopLoss_Pos") || 
       !GlobalVariableCheck(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos")) {

      Alert(EAName + "| " + "ATTENZIONE! Gestire le posizioni manualmente!");
      return(0);
   }

   if (ActiveDebug) {
      Print(EAName + "| " + "StopLoss_Pos  : ", GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "StopLoss_Pos"));
      Print(EAName + "| " + "TakeProfit_Pos: ", GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos"));
   }  
   
   //Verifico se devo chiudere la posizione
   if (OrderSelect(TicketPos, SELECT_BY_TICKET)) {
      //Verifico che la posizione sia aperta
      if (OrderCloseTime() == 0) {
         if (OrderType() == OP_BUY) {
            if ((Bid >= GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos") && GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos") > 0) ||
                (Bid <= GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "StopLoss_Pos"))) {

               for (c=0;c<NumberOfTries;c++) {
                  RefreshRates();                   
                
                  OrderClose(OrderTicket(),OrderLots(), Bid, Slippage, Lime);
                  err = GetLastError();
                  if (err == 0) {
                     break;
                  }
                  else {
                     Alert(EAName + "| " + "Errore OrderClose BUY: ", err);
                     if (err==4 || err==137 ||err==146 || err==136) {
                        Sleep(3000);
                        continue;
                     }
                     else {
                        break;
                     }
                  }      
               }
            }
         }   
         if (OrderType() == OP_SELL) {
            if ((Ask <= GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos") && GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos") > 0) ||
                (Ask >= GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "StopLoss_Pos"))) {

               for (c=0;c<NumberOfTries;c++) {
                  RefreshRates();                   
   
                  OrderClose(OrderTicket(),OrderLots(), Ask, Slippage, Lime);
                  err = GetLastError();
                  if (err == 0) {
                     break;
                  }
                  else {
                     Alert(EAName + "| " + "Errore OrderClose SELL: ", err);
                     if (err==4 || err==137 ||err==146 || err==136) {
                        Sleep(3000);
                        continue;
                     }
                     else {
                        break;
                     }
                  }      
               }
            }
         }   
      }
   }   
}
//+------------------------------------------------------------------+
//|Recupero l'ultimo segnale ARROW                                   |
//+------------------------------------------------------------------+
void LastSignalArrow(int intBars) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "LastSignalArrow(int intBars) ", intBars);

   double   dblICustom0;
   double   dblICustom1;

   int      i;

   boolArrowSell = FALSE;
   boolArrowBuy = FALSE;
      
   //Cerco nelle barre precedenti l'ultimo segnale ARROW
   //all'interno dell'orario di Trade
   for (i = intBars; i <= Bars; i++) {
      //FDM Entry Arrows with Alerts indicator: Quando vi  il segnale, il valore di uno dei 2 buffer
      // impostato al livello del prezzo. Se non vi sono segnali, il valore di default  2147483647 EMPTY_VALUE
      //Buffer 0 segnale un BUY
      //Buffer 1 segnala un SELL
      dblICustom0 = iCustom(Symbol(), Period(), "FDM Entry Arrows with Alerts",FALSE,0, i);
      dblICustom1 = iCustom(Symbol(), Period(), "FDM Entry Arrows with Alerts",FALSE,1, i);

      if (dblICustom0 == EMPTY_VALUE) {
         if (dblICustom1 == EMPTY_VALUE) {
         }
         else {
            boolArrowSell  = TRUE;
            intBarArrow    = i;
            dtArrow        = Time[i];
            if (ActiveDebug) {
               Print(EAName + "| " + "FDM Entry Arrows with Alerts-0:", dblICustom0);
               Print(EAName + "| " + "FDM Entry Arrows with Alerts-1:", dblICustom1);
               Print(EAName + "| " + "Barra con il segnale Sell     :", intBarArrow);
               Print(EAName + "| " + "Orario della barra            :", FormatDate(dtArrow, "AAAAMMGG hh:mm:ss"));
            }     
            break;
         }
      } 
      else {
         boolArrowBuy      = TRUE;         
         intBarArrow       = i;
         dtArrow           = Time[i];
         if (ActiveDebug) {
            Print(EAName + "| " + "FDM Entry Arrows with Alerts-0:", dblICustom0);
            Print(EAName + "| " + "FDM Entry Arrows with Alerts-1:", dblICustom1);
            Print(EAName + "| " + "Barra con il segnale Buy      :", intBarArrow);
            Print(EAName + "| " + "Orario della barra            :", FormatDate(dtArrow, "AAAAMMGG hh:mm:ss"));
         }     
         break;
      }      
   }   
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int RecuperaPosizione() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "RecuperaPosizione()");

   int intReturn = 0;

   int i = 0;

   //Recupero il ticket sulla posizione aperta se esiste
   for (i = 0; i < OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && StringFind(OrderComment(), EAName) == 0) {
         if (OrderCloseTime() == 0) {
            intReturn = OrderTicket();
         }
      }
   }

   //Recupero il ticket dalla posizione chiusa 
   //solo se  stata aperta dopo l'ultimo segnale ARROW
   if (intReturn == 0) {
      for (i = 0; i < OrdersHistoryTotal(); i++) {
         OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && StringFind(OrderComment(), EAName) == 0) {
            if (OrderOpenTime() >= dtArrow) {
               intReturn = OrderTicket();
            }
         }
      }
   }

   if (ActiveDebug) {
      Print(EAName + "| " + "intReturn: ", intReturn);
   }
   
   return (intReturn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetStopLoss(string strSignal) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "GetStopLoss(string strSignal) ", strSignal);
   
   double dblReturn = 0;
   double StopLossADR;
    
   if (ActiveDebug)
      Print(EAName + "| " + "MarketInfo(Symbol(),MODE_STOPLEVEL) ", MarketInfo(Symbol(),MODE_STOPLEVEL));

   //Recupero il valore della label "Avg Daily Range" dell'indicatore FDM ADR
   StopLossADR = StrToDouble(ObjectDescription("FDM ADR3"));
   StopLossADR = StopLossADR * SetBrokerX(); 
   
   if (StopLoss < StopLossADR)
      StopLoss = StopLossADR;
      
   //Imposto lo StopLoss e verifico che sia congruente con i limiti del broker
   if (strSignal == "BUY") {
      if (StopLoss < MarketInfo(Symbol(),MODE_STOPLEVEL))
         dblReturn = Bid - MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
      else
         dblReturn = Bid - StopLoss*Point;
   }      

   if (strSignal == "SELL") {
      if (StopLoss < MarketInfo(Symbol(),MODE_STOPLEVEL))
         dblReturn = Ask + MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
      else
         dblReturn = Ask + StopLoss*Point;
   }      
   
   if (Hidden_TPSL) {
      GlobalVariableSet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "StopLoss_Pos", NormalizeDouble(dblReturn, Digits));

      if (ActiveDebug) {
         Print(EAName + "| " + "StopLoss_Pos: ", GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "StopLoss_Pos"));
      }  
      
      dblReturn = 0;
   }
         
   if (ActiveDebug)
      Print(EAName + "| " + "dblReturn ", dblReturn);
   
   return (NormalizeDouble(dblReturn, Digits));
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetTakeProfit(string strSignal) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "GetTakeProfit(string strSignal) ", strSignal);
   
   double dblReturn = 0;

   double dblSupporto;
   double dblResistenza;
   
   if (TakeProfit == 0) {
      dblReturn = 0;
   }
   else {
      //Imposto il TakeProfit e verifico che sia congruente con i limiti del broker
      if (strSignal == "BUY") {
         if (TakeProfit < MarketInfo(Symbol(),MODE_STOPLEVEL))
            dblReturn = Bid + MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
         else
            dblReturn = Bid + TakeProfit*Point;         
      }         

      if (strSignal == "SELL") {
         if (TakeProfit < MarketInfo(Symbol(),MODE_STOPLEVEL))
            dblReturn = Ask - MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
         else
            dblReturn = Ask - TakeProfit*Point;
      }         
   }

   if (CloseOnRulesSystem) {
      //INDICATORE: FDM Support and Resistance
      dblResistenza   = iCustom(Symbol(), Period(), "FDM Support and Resistance",0, 0);
      dblSupporto     = iCustom(Symbol(), Period(), "FDM Support and Resistance",1, 0);

      if (ActiveDebug) {
         Print(EAName + "| " + "FDM Support and Resistance-0:", dblSupporto);
         Print(EAName + "| " + "FDM Support and Resistance-1:", dblResistenza);
      }   

      if (strSignal == "BUY") {         
         if ((dblResistenza - Bid) > DistanceFromSR*Point)
            dblReturn = dblResistenza-(MarketInfo(Symbol(),MODE_SPREAD)*Point);         
      }         

      if (strSignal == "SELL") {
         if ((Ask - dblSupporto) > DistanceFromSR*Point)
            dblReturn = dblSupporto+(MarketInfo(Symbol(),MODE_SPREAD)*Point);
      }         
   }

   if (Hidden_TPSL) {
      GlobalVariableSet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos", NormalizeDouble(dblReturn, Digits));

      if (ActiveDebug) {
         Print(EAName + "| " + "TakeProfit_Pos: ", GlobalVariableGet(EAName + Symbol() + DoubleToStr(MagicNumber,0) + "TakeProfit_Pos"));
      }  

      dblReturn = 0;
   }
                  
   if (ActiveDebug)
      Print(EAName + "| " + "dblReturn ", dblReturn);
   
   return (NormalizeDouble(dblReturn, Digits));
}
//+------------------------------------------------------------------+
//|Verifico che ci sia il segnale di Trend come definito dal         |
//|Trading System                                                    |
//+------------------------------------------------------------------+
bool GetSignal(int intBars) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "GetSignal(int intBars) ", intBars);

   bool     boolReturn = FALSE;

   double   dblICustom0;
   double   dblICustom1;
   double   dblICustom2;
   double   dblICustom3;
   double   dblICustom4;
   double   dblICustom5;
   
   int      i;

   bool     boolInd1Buy;
   bool     boolInd1Sell;
   bool     boolInd2Buy;
   bool     boolInd2Sell;
   bool     boolInd3Buy;
   bool     boolInd3Sell;
   bool     boolInd4Buy;
   bool     boolInd4Sell;
   bool     boolInd5Buy;
   bool     boolInd5Sell;
   bool     boolInd6Buy;
   bool     boolInd6Sell;
   bool     boolInd7Buy;
   bool     boolInd7Sell;
   bool     boolInd8Buy;
   bool     boolInd8Sell;

   string   strNote1   = "Chart Time Frame";
   string   strNote2   = "0=current time frame";
   string   strNote3   = "1=M1, 5=M5, 15=M15, 30=M30";
   string   strNote4   = "60=H1, 240=H4, 1440=D1";
   string   strNote5   = "10080=W1, 43200=MN1";
   int      intPeriod;   

   LastSignalArrow(intBars);
      
   //Se ho trovato un segnale BUY o SELL e non ho superato il massimo numero di barre dal segnale, 
   //allora verifico gli 8 indicatori
   if ((boolArrowBuy || boolArrowSell) && (intBarArrow - intBars) <= MaxBarAfterArrow) {

      boolInd1Buy  = FALSE;
      boolInd1Sell = FALSE;
      boolInd2Buy  = FALSE;
      boolInd2Sell = FALSE;
      boolInd3Buy  = FALSE;
      boolInd3Sell = FALSE;
      boolInd4Buy  = FALSE;
      boolInd4Sell = FALSE;
      boolInd5Buy  = FALSE;
      boolInd5Sell = FALSE;
      boolInd6Buy  = FALSE;
      boolInd6Sell = FALSE;
      boolInd7Buy  = FALSE;
      boolInd7Sell = FALSE;
      boolInd8Buy  = FALSE;
      boolInd8Sell = FALSE;

      if (ActiveDebug) {
         Print(EAName + "| " + "Barra degli 8 indicatori:", intBars);
         Print(EAName + "| " + "Data della barra        :", FormatDate(Time[intBars], "AAAAMMGG hh:mm:ss"));
      }   
      
      //INDICATORE 1: FDM Buy Sell Pressure
      //Se verde buffer 1 diverso da EMPTY_VALUE altrimenti se rosso
      //buffer 0 diverso da EMPTY_VALUE. I buffer 2 e 3 sembrano non essere significativi per il nostro scopo 
      //Buffer 0 segnala un SELL
      //Buffer 1 segnala un BUY
      dblICustom0 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",0, intBars);
      dblICustom1 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",1, intBars);
      //dblICustom2 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",2, intBars);
      //dblICustom3 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure",3, intBars);

      if (ActiveDebug) {
         Print(EAName + "| " + "FDM Buy Sell Pressure-0:", dblICustom0);
         Print(EAName + "| " + "FDM Buy Sell Pressure-1:", dblICustom1);
         //Print(EAName + "| " + "FDM Buy Sell Pressure-2:", dblICustom2);
         //Print(EAName + "| " + "FDM Buy Sell Pressure-3:", dblICustom3);
      }   

      if (dblICustom0 == EMPTY_VALUE) {
         if (dblICustom1 == EMPTY_VALUE) {
         }
         else {
            boolInd1Buy = TRUE;
         }
      }
      else {
         boolInd1Sell = TRUE;
      }         

      //INDICATORE 2: FDM Buy Sell Pressure #2
      //Se verde buffer 1 diverso da EMPTY_VALUE altrimenti se rosso
      //buffer 0 diverso da EMPTY_VALUE. I buffer 2 e 3 sembrano non essere significativi per il nostro scopo 
      //Buffer 0 segnala un SELL
      //Buffer 1 segnala un BUY
      dblICustom0 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",0, intBars);
      dblICustom1 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",1, intBars);
      //dblICustom2 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",2, intBars);
      //dblICustom3 = iCustom(Symbol(), Period(), "FDM Buy Sell Pressure #2",3, intBars);

      if (ActiveDebug) {
         Print(EAName + "| " + "FDM Buy Sell Pressure #2-0:", dblICustom0);
         Print(EAName + "| " + "FDM Buy Sell Pressure #2-1:", dblICustom1);
         //Print(EAName + "| " + "FDM Buy Sell Pressure #2-2:", dblICustom2);
         //Print(EAName + "| " + "FDM Buy Sell Pressure #2-3:", dblICustom3);
      }   

      if (dblICustom0 == EMPTY_VALUE) {
         if (dblICustom1 == EMPTY_VALUE) {
         }
         else {
            boolInd2Buy = TRUE;
         }
      }
      else {
         boolInd2Sell = TRUE;
      }         

      //INDICATORE 3: FDM Fast Trend
      //Se verde buffer 0 diverso da 0 altrimenti se rosso
      //buffer 1 diverso da 0. Il buffer 2 non  significativo al nostro scopo 
      //Buffer 0 segnala un BUY
      //Buffer 1 segnala un SELL
      dblICustom0 = iCustom(Symbol(), Period(), "FDM Fast Trend", 3000, 0, intBars);
      dblICustom1 = iCustom(Symbol(), Period(), "FDM Fast Trend", 3000, 1, intBars);
      //dblICustom2 = iCustom(Symbol(), Period(), "FDM Fast Trend", 3000, 2, intBars);

      if (ActiveDebug) {
         Print(EAName + "| " + "FDM Fast Trend-0:", dblICustom0);
         Print(EAName + "| " + "FDM Fast Trend-1:", dblICustom1);
         //Print(EAName + "| " + "FDM Fast Trend-2:", dblICustom2);
      }   

      if (dblICustom0 == 0) {
         if (dblICustom1 == 0) {
         }
         else {
            boolInd3Sell = TRUE;
         }
      }
      else {
         boolInd3Buy = TRUE;
      }         

      //INDICATORE 4: FDM_Multi-Trend
      //Se verde buffer 1 diverso da 0 altrimenti se rosso
      //buffer 0 diverso da 0. I buffer 2 e 3 sembrano non essere significativi per il nostro scopo 
      //Buffer 0 segnala un SELL
      //Buffer 1 segnala un BUY
      dblICustom0 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 0, intBars);
      dblICustom1 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 1, intBars);
      //dblICustom2 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 2, intBars);
      //dblICustom3 = iCustom(Symbol(), Period(), "FDM_Multi-Trend",Period(), 3, intBars);
         
      if (ActiveDebug) {
         Print(EAName + "| " + "FDM_Multi-Trend-0:", dblICustom0);
         Print(EAName + "| " + "FDM_Multi-Trend-1:", dblICustom1);
         //Print(EAName + "| " + "FDM_Multi-Trend-2:", dblICustom2);
         //Print(EAName + "| " + "FDM_Multi-Trend-3:", dblICustom3);
      }   
         
      if (dblICustom0 == 0) {
         if (dblICustom1 == 0) {
         }
         else {
            boolInd4Buy = TRUE;
         }
      }
      else {
         boolInd4Sell = TRUE;
      }         

      //INDICATORE 5: FDM Oscillator (con current TF)
      //Se verde buffer 2 o 4 uguale a 100 altrimenti se rosso
      //buffer 3 o 5 uguale a 100. I buffer 0 e 1 sembrano non essere significativi per il nostro scopo 
      //Sono 4 indicatori uguali con tf diverso. Prende il tf corrente
      //Buffer 2 e 4 segnala un BUY
      //Buffer 3 e 5 segnala un SELL

      intPeriod = Period();

      //dblICustom0 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 0, intBars);
      //dblICustom1 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 1, intBars);
      dblICustom2 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 2, intBars);
      dblICustom3 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 3, intBars);
      dblICustom4 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 4, intBars);
      dblICustom5 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 5, intBars);

      if (ActiveDebug) {
         //Print(EAName + "| " + "FDM Oscillator-TF1-0:", dblICustom0);
         //Print(EAName + "| " + "FDM Oscillator-TF1-1:", dblICustom1);
         Print(EAName + "| " + "FDM Oscillator-TF1-2:", dblICustom2);
         Print(EAName + "| " + "FDM Oscillator-TF1-3:", dblICustom3);
         Print(EAName + "| " + "FDM Oscillator-TF1-4:", dblICustom4);
         Print(EAName + "| " + "FDM Oscillator-TF1-5:", dblICustom5);
      }   

      if ((dblICustom2 == 100 || dblICustom4 == 100) && dblICustom1 == 1) {
         boolInd5Buy = TRUE;
      }
      else {
         if ((dblICustom3 == 100 || dblICustom5 == 100) &&  dblICustom0 == 1) {
            boolInd5Sell = TRUE;
         }
      }

      //INDICATORE 6: FDM Oscillator (con current TF + 1)
      //Se verde buffer 2 o 4 uguale a 100 altrimenti se rosso
      //buffer 3 o 5 uguale a 100. I buffer 0 e 1 sembrano non essere significativi per il nostro scopo 
      //Sono 4 indicatori uguali con tf diverso. Prende il tf corrente + 1
      //Buffer 2 e 4 segnala un BUY
      //Buffer 3 e 5 segnala un SELL

      switch (Period()) {
         case 5: 
            intPeriod = 15;
            break;
         case 15: 
            intPeriod = 30;
            break;
         case 30: 
            intPeriod = 60;
            break;
         case 60: 
            intPeriod = 240;
            break;
         case 240: 
            intPeriod = 1440;
            break;
      }         
         
      //dblICustom0 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 0, intBars);
      //dblICustom1 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 1, intBars);
      dblICustom2 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 2, intBars);
      dblICustom3 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 3, intBars);
      dblICustom4 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 4, intBars);
      dblICustom5 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 5, intBars);

      if (ActiveDebug) {
         //Print(EAName + "| " + "FDM Oscillator-TF2-0:", dblICustom0);
         //Print(EAName + "| " + "FDM Oscillator-TF2-1:", dblICustom1);
         Print(EAName + "| " + "FDM Oscillator-TF2-2:", dblICustom2);
         Print(EAName + "| " + "FDM Oscillator-TF2-3:", dblICustom3);
         Print(EAName + "| " + "FDM Oscillator-TF2-4:", dblICustom4);
         Print(EAName + "| " + "FDM Oscillator-TF2-5:", dblICustom5);
      }   

      if ((dblICustom2 == 100 || dblICustom4 == 100) && dblICustom1 == 1) {
         boolInd6Buy = TRUE;
      }
      else {
         if ((dblICustom3 == 100 || dblICustom5 == 100) &&  dblICustom0 == 1) {
            boolInd6Sell = TRUE;
         }
      }

      //INDICATORE 7: FDM Oscillator (con current TF + 2)
      //Se verde buffer 2 o 4 uguale a 100 altrimenti se rosso
      //buffer 3 o 5 uguale a 100. I buffer 0 e 1 sembrano non essere significativi per il nostro scopo 
      //Sono 4 indicatori uguali con tf diverso. Prende il tf corrente + 2
      //Buffer 2 e 4 segnala un BUY
      //Buffer 3 e 5 segnala un SELL

      switch (Period()) {
         case 5: 
            intPeriod = 30;
            break;
         case 15: 
            intPeriod = 60;
            break;
         case 30: 
            intPeriod = 240;
            break;
         case 60: 
            intPeriod = 1440;
            break;
         case 240: 
            intPeriod = 10080;
            break;
      }         
         
      //dblICustom0 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 0, intBars);
      //dblICustom1 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 1, intBars);
      dblICustom2 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 2, intBars);
      dblICustom3 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 3, intBars);
      dblICustom4 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 4, intBars);
      dblICustom5 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 5, intBars);

      if (ActiveDebug) {
         //Print(EAName + "| " + "FDM Oscillator-TF3-0:", dblICustom0);
         //Print(EAName + "| " + "FDM Oscillator-TF3-1:", dblICustom1);
         Print(EAName + "| " + "FDM Oscillator-TF3-2:", dblICustom2);
         Print(EAName + "| " + "FDM Oscillator-TF3-3:", dblICustom3);
         Print(EAName + "| " + "FDM Oscillator-TF3-4:", dblICustom4);
         Print(EAName + "| " + "FDM Oscillator-TF3-5:", dblICustom5);
      }   

      if ((dblICustom2 == 100 || dblICustom4 == 100) && dblICustom1 == 1) {
         boolInd7Buy = TRUE;
      }
      else {
         if ((dblICustom3 == 100 || dblICustom5 == 100) &&  dblICustom0 == 1) {
            boolInd7Sell = TRUE;
         }
      }

      //INDICATORE 8: FDM Oscillator (con current TF + 3)
      //Se verde buffer 2 o 4 uguale a 100 altrimenti se rosso
      //buffer 3 o 5 uguale a 100. I buffer 0 e 1 sembrano non essere significativi per il nostro scopo 
      //Sono 4 indicatori uguali con tf diverso. Prende il tf corrente + 3
      //Buffer 2 e 4 segnala un BUY
      //Buffer 3 e 5 segnala un SELL

      switch (Period()) {
         case 5: 
            intPeriod = 60;
            break;
         case 15: 
            intPeriod = 240;
            break;
         case 30: 
            intPeriod = 1440;
            break;
         case 60: 
            intPeriod = 10080;
            break;
         case 240: 
            intPeriod = 43200;
            break;
      }         
         
      //dblICustom0 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 0, intBars);
      //dblICustom1 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 1, intBars);
      dblICustom2 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 2, intBars);
      dblICustom3 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 3, intBars);
      dblICustom4 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 4, intBars);
      dblICustom5 = iCustom(Symbol(), Period(), "FDM Oscillator", strNote1, strNote2, strNote3, strNote4, strNote5, intPeriod, 5, intBars);

      if (ActiveDebug) {
         //Print(EAName + "| " + "FDM Oscillator-TF4-0:", dblICustom0);
         //Print(EAName + "| " + "FDM Oscillator-TF4-1:", dblICustom1);
         Print(EAName + "| " + "FDM Oscillator-TF4-2:", dblICustom2);
         Print(EAName + "| " + "FDM Oscillator-TF4-3:", dblICustom3);
         Print(EAName + "| " + "FDM Oscillator-TF4-4:", dblICustom4);
         Print(EAName + "| " + "FDM Oscillator-TF4-5:", dblICustom5);
      }   

      if ((dblICustom2 == 100 || dblICustom4 == 100) && dblICustom1 == 1) {
         boolInd8Buy = TRUE;
      }
      else {
         if ((dblICustom3 == 100 || dblICustom5 == 100) &&  dblICustom0 == 1) {
            boolInd8Sell = TRUE;
         }
      }

      if (boolInd1Buy && boolInd2Buy && boolInd3Buy && boolInd4Buy && boolInd5Buy && boolInd6Buy && boolInd7Buy && boolInd8Buy && boolArrowBuy) {
         boolReturn = TRUE;
         strSignal = "BUY";
      }
      else {
         if (boolInd1Sell && boolInd2Sell && boolInd3Sell && boolInd4Sell && boolInd5Sell && boolInd6Sell && boolInd7Sell && boolInd8Sell && boolArrowSell) {
            boolReturn = TRUE;
            strSignal = "SELL";
         }
      }
   }   

   if (ActiveDebug) {
      if (boolArrowBuy) {
         Print(EAName + "| " + "Segnale Buy");
         Print(EAName + "| " + "Indicatore 1: ", boolInd1Buy);
         Print(EAName + "| " + "Indicatore 2: ", boolInd2Buy);
         Print(EAName + "| " + "Indicatore 3: ", boolInd3Buy);
         Print(EAName + "| " + "Indicatore 4: ", boolInd4Buy);
         Print(EAName + "| " + "Indicatore 5: ", boolInd5Buy);
         Print(EAName + "| " + "Indicatore 6: ", boolInd6Buy);
         Print(EAName + "| " + "Indicatore 7: ", boolInd7Buy);
         Print(EAName + "| " + "Indicatore 8: ", boolInd8Buy);
      }         

      if (boolArrowSell) {
         Print(EAName + "| " + "Segnale Sell");
         Print(EAName + "| " + "Indicatore 1: ", boolInd1Sell);
         Print(EAName + "| " + "Indicatore 2: ", boolInd2Sell);
         Print(EAName + "| " + "Indicatore 3: ", boolInd3Sell);
         Print(EAName + "| " + "Indicatore 4: ", boolInd4Sell);
         Print(EAName + "| " + "Indicatore 5: ", boolInd5Sell);
         Print(EAName + "| " + "Indicatore 6: ", boolInd6Sell);
         Print(EAName + "| " + "Indicatore 7: ", boolInd7Sell);
         Print(EAName + "| " + "Indicatore 8: ", boolInd8Sell);
      }         
   }
   
   if (ActiveDebug)
      Print(EAName + "| " + "boolReturn ", boolReturn);
   
   return(boolReturn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetComment() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "GetComment()");

   string strReturn = "";

   strReturn = EAName;
 
   if (ActiveDebug)
      Print(EAName + "| " + "strReturn ", strReturn);

   return (strReturn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTradeTime(datetime dtData) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "IsTradeTime() ", FormatDate(dtData, "AAAAMMGG hh:mm:ss"));

   bool boolReturn = FALSE;

   if (OpenHour == 0 && CloseHour == 24)
      boolReturn = TRUE;
   else   
      if (OpenHour < CloseHour && TimeHour(dtData) >= OpenHour && TimeHour(dtData) < CloseHour) 
         boolReturn = TRUE;
      else
         if (OpenHour > CloseHour && (TimeHour(dtData) > OpenHour && TimeHour(dtData) < CloseHour) || (TimeHour(dtData) < OpenHour && TimeHour(dtData) < CloseHour)) 
            boolReturn = TRUE;
        
   if (ActiveDebug)
      Print(EAName + "| " + "Return ", boolReturn);

   return (boolReturn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetLots(double dblStopLoss) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "GetLots() ", dblStopLoss);

   double dblReturn;

   double dblMaxLots;
   double dblLotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
   double dblLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double dblMinLot = NormalizeDouble(MarketInfo(Symbol(), MODE_MINLOT), 2);
   double dblMaxLot = NormalizeDouble(MarketInfo(Symbol(), MODE_MAXLOT), 2);

   //Se LotsOptimized  acceso viene calcolata in automatico la quantit di lotti in base alla
   //percentuale di rischio impostata
   //Se LotsOptimized  spento, viene preso il valore del parametro esterno Lots
   
   if (LotsOptimized == TRUE) 
      dblReturn = NormalizeDouble(AccountFreeMargin() * (Risk / 100) / (MarketInfo(Symbol(),MODE_TICKVALUE) * dblStopLoss), 2);
   else 
      dblReturn = Lots;

   if (dblReturn < dblMinLot) 
      dblReturn = dblMinLot;
   if (MaxLots > 0.0 && MaxLots < dblMaxLot) 
      dblMaxLots = MaxLots;
   else 
      dblMaxLots = dblMaxLot;
   if (dblReturn > dblMaxLots) 
      dblReturn = dblMaxLots;

   if (AccountFreeMarginCheck(Symbol(), OP_BUY, dblReturn) <= 0.0 || GetLastError() == 134/* NOT_ENOUGH_MONEY */) 
      Alert(EAName + "| " + "Deposito insufficiente.Ridurre i lotti! Free Margin = ", AccountFreeMargin());

   if (dblLotStep == 1)
      dblReturn = NormalizeDouble(dblReturn, 0);
   if (dblLotStep == 0.1)
      dblReturn = NormalizeDouble(dblReturn, 1);
   if (dblLotStep == 0.01)
      dblReturn = NormalizeDouble(dblReturn, 2);
      
   if (ActiveDebug)
      Print(EAName + "| " + "dblReturn ", dblReturn);

   return (dblReturn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string FormatDate(datetime dtDate, string strFormat) {
   string strReturn;

   //Formato di default
   strReturn = TimeToStr(dtDate, TIME_DATE|TIME_SECONDS);
   
   if (strFormat == "AAAA-MM-GG hh:mm:ss") {
      strReturn = StringConcatenate(
                                    TimeYear(dtDate),
                                    "-",
                                    TimeMonth(dtDate),
                                    "-",
                                    TimeDay(dtDate),
                                    " ",
                                    TimeHour(dtDate),
                                    ":",
                                    TimeMinute(dtDate),
                                    ":",
                                    TimeSeconds(dtDate)                                   
                                   );   
   }                                      
   
   return (strReturn);
}
//+------------------------------------------------------------------+
//|Serve per gestire i broker che hanno un numero di decimali diversi|
//|da 2 o 4. Ad esempio il broket ALPARI                             |
//+------------------------------------------------------------------+
int SetBrokerX() {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "SetBrokerX()");

   int intReturn;
   
   if (Digits == 3 || Digits == 5) 
      intReturn = 10;
   else 
      intReturn = 1;

   if (ActiveDebug)
      Print("Debug: " + "intReturn ", intReturn);

   return (intReturn);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool TestCorrelation(string strType) {
   if (ActiveDebug)
      Print(EAName + "| " + "Function " + "TestCorrelation(string strType) ", strType);

   bool        boolReturn   = TRUE;
   
   double      dblICustom  = 0;
   int         intDelta    = 0;
   bool        boolCorrelation = FALSE;

   //Scorro tutte le posizioni aperte
   for (int i = 0; i < OrdersTotal(); i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      //Se il posizione  aperta e se la posizione  stata aperta dall'EA
      if (OrderCloseTime() == 0 && StringFind(OrderComment(), EAName, 0) == 0) {
         dblICustom = iCustom(Symbol(), Period(), "CorrelationPair", OrderSymbol(), c_Points, c_UseOpen, c_UseClose, c_UseHigh, c_UseLow, c_CalcBars, 0, 1);
         dblICustom = MathRound(dblICustom * 100);

         if (ActiveDebug)
            Print(EAName + "| " + "Percentuale di correlazione tra " + Symbol() + " e " + OrderSymbol() +  " > ", dblICustom);
                  
         //La posizione che voglio aprire  dello stesso segno di quella su cui ho calcolato la correlazione
         if ((OrderType() == OP_BUY && strType == "BUY") || (OrderType() == OP_SELL && strType == "SELL")) {
            if (dblICustom >= PercCorrelation) {
               intDelta = intDelta + 1;
               boolCorrelation = TRUE;
            }
            else {
               if (dblICustom <= PercCorrelation*(-1)) {
                  intDelta = intDelta - 1;
               }                  
            }                  
         } 
         //La posizione che voglio aprire  di segno contrario a quella su cui ho calcolato la correlazione
         else {
            if (dblICustom >= PercCorrelation) {
               intDelta = intDelta - 1;
            }
            else {
               if (dblICustom <= PercCorrelation*(-1)) {
                  intDelta = intDelta + 1;
                  boolCorrelation = TRUE;
               }
            }
         }                    
      }
   } 

   if (TypeCorrelation == 1) {
      if (ActiveDebug)
         Print(EAName + "| " + "Delta di correlazione ", intDelta);
 
      if (intDelta <= 0)
         boolReturn = TRUE;
      else
         boolReturn = FALSE;  
   }
   else {
      if (boolCorrelation)
         boolReturn = FALSE;
      else
         boolReturn = TRUE;         
   }

   if (ActiveDebug)
      Print(EAName + "| " + "Return ", boolReturn);

   return (boolReturn);
}

